---
title: RegExp.prototype.compile()
slug: Web/JavaScript/Reference/Global_Objects/RegExp/compile
tags:
  - Deprecated
  - JavaScript
  - Method
  - Prototype
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}} {{deprecated_header}}</div>

<p>The deprecated <code><strong>compile</strong></code><strong><code>()</code></strong> method is used to (re-)compile a regular expression during execution of a script. It is basically the same as the <code>RegExp</code> constructor.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><var>regexObj</var>.compile(<var>pattern, flags</var>)</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>pattern</code></dt>
 <dd>The text of the regular expression.</dd>
 <dt><code>flags</code></dt>
 <dd>
 <p>If specified, flags can have any combination of the following values:</p>

 <dl>
  <dt><code>g</code></dt>
  <dd>global match</dd>
  <dt><code>i</code></dt>
  <dd>ignore case</dd>
  <dt><code>m</code></dt>
  <dd>multiline; treat beginning and end characters (^ and $) as working over multiple lines (i.e., match the beginning or end of <em>each</em> line (delimited by \n or \r), not only the very beginning or end of the whole input string)</dd>
  <dt><code>y</code></dt>
  <dd>sticky; matches only from the index indicated by the <code>lastIndex</code> property of this regular expression in the target string (and does not attempt to match from any later indexes).</dd>
 </dl>
 </dd>
</dl>

<h2 id="Description">Description</h2>

<p> The <code>compile</code> method is deprecated. You can just use the <code>RegExp</code> constructor to achieve the same effect.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_compile">Using <code>compile()</code></h3>

<p>The following example shows how to recompile a regular expression with a new pattern and a new flag.</p>

<pre class="brush: js">var regexObj = new RegExp('foo', 'gi');
regexObj.compile('new foo', 'g');
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-regexp.prototype.compile', 'RegExp.prototype.compile')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.compile")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RegExp")}}</li>
</ul>
